function showMainButton(player_index_or_name)
    local player = game.players[player_index_or_name]
    if (not player or not player.valid) then
        return false
    end
    if (not player.gui.center.BMS_mainButton) then
        player.gui.center.add({type = "button", name = "BMS_mainButton", caption = "Announce Mod Settings"})
    end
end

function showAllMainButton()
    for _, player in pairs(game.players) do
        showMainButton(player.index)
    end
end


script.on_init(function()
    showAllMainButton()
end)

script.on_event(defines.events.on_player_created, function(event)
    showMainButton(event.player_index)
end)

script.on_event(defines.events.on_gui_click, function(event)
    local player = game.players[event.player_index]

    player.print("String  = " .. settings.player["BMS_string"].value)

    player.print("Boolean = " .. tostring(settings.player["BMS_bool"].value))

    player.print("Int     = " .. tostring(settings.player["BMS_int"].value))

    player.print("Double = " .. tostring(settings.player["BMS_double"].value))
end)
